#!/bin/sh
#kidistb.tcl
#Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : kidistb.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version $Id: kidistb.tcl,v 1.6 2006/11/12 08:22:31 david Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################

global tid canvw canvh indexpage totalpage listdata nomf taillefont indexlibre CanvasGere tamponpage Home tabevent basedir bgn bgl crtlflag nompage


set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source path.tcl
source msg.tcl

initapp $plateforme
loadlib $plateforme



#wm deiconify .

set nomf ""
set imgid 0
set id 0
set c .frame.c
set bgn #ffff80
set bgl #ff80c0
set font2 ""
set son 1
set tool 0
set totalpage 1
set indexpage 0
set indexlibre 0
set CanvasGere 0
set tamponpage ""
set crtlflag 0
set tabevent(canvas) {pageenter {} pageleave {}}
set nompage(0) "[mc {Page1}]"
set listdata {{} {set indexlibre $indexlibre}}
#wm overrideredirect . 1


. configure -background #ffff80
source tool.tcl
source event.tcl
#source son.tcl
source texte.tcl
source enveloppe.tcl
source utils.tcl
source image.tcl
source editeur.tcl
source bouton1.tcl
source polygon.tcl
source bouton2.tcl
source choixpoly.tcl
source can2svg.tcl
source can2html.tcl
wm protocol . WM_DELETE_WINDOW "quitte $c"
####################################################""
#procdure principale
#######################################################"

proc cplace {c} {
   global tid canvw canvh taillefont tabobj tabevent indexlibre
      $c delete all

switch [winfo screenwidth .] {
1280 {
set param {600 651 700 581 139 497 588 215 612 585 429 1.75 1.75}
}
1024 {
set param {500 551 600 481 39 397 488 115 512 485 329 1.75 1.75}
}
800 {
set param {366 472 600 348 27 397 365 110 512 362 295 1.30 1.30}
}
default {
set param {283 336 600 273 31 397 286 102 512 276 231 0.82 0.82}
}
}
set st1 [mc {Ouvrez l'exemple conte et appuyez sur le bouton Jouer .}]
set st2 [mc {Logiciel de creation multimedia pour les enfants.}]
createtexte $c [lindex $param 0] [lindex $param 1] $st1 blue [lindex $param 2] hauteur white Helvetica 2 blue uident1 sep
set tabobj(uident1) uident1
set tabevent(uident1) {enter {} leave {} click {}}
createtexte $c [lindex $param 3] [lindex $param 4] {Kidistoryboard} blue [lindex $param 5] hauteur white Helvetica 6 blue uident2 sep
set tabobj(uident2) uident2
set tabevent(uident2) {enter {} leave {} click {}}
createtexte $c [lindex $param 6] [lindex $param 7] $st2 "" [lindex $param 8] hauteur White Helvetica 2 "" uident3 sep
set tabobj(uident3) uident3
set tabevent(uident3) {enter {} leave {} click {}}
#createimage $c {background.gif} [lindex $param 9] [lindex $param 10] [lindex $param 11] [lindex $param 12] uident5
set bimage [getimgid]
image create photo $bimage -file [file join images background.gif]
CZoom $bimage [lindex $param 11] [lindex $param 12]
set id [getid]
$c create image [lindex $param 9] [lindex $param 10] -image $bimage
set tabobj(uident5) uident5
set tabevent(uident5) {enter {} leave {} click {}}
set tabevent(canvas) {pageenter {} pageleave {}}
$c configure -background Blue
set indexlibre 5
 }


###############################################################
#appel de la procdure principale
##############################################################"
cplace $c
focus $c


#############################################################
#gestion des evnements
##########################################################
bind $c <ButtonPress-1> "CanvasStart $c %x %y"
bind $c <B1-Motion> "CanvasDrag $c %x %y"
bind $c <ButtonRelease-1> "CanvasStopDrag $c %x %y"
bind $c <KeyPress> "setcrtl %K"
bind $c <KeyRelease> "unsetcrtl"

############################################################################
#gestion du jeu et des dplacements
#############################################################################
##############################################################################
proc CanvasStart {c x y} {

global lastX lastY CanvasGere tid
set CanvasGere 0
set lastX [$c canvasx $x]
set lastY [$c canvasy $y]
$c focus ""
#combien y a-t-il d'objets sous le pointeur au moment du click?
if {[llength [$c find overlapping [expr $x -1] [expr $y -1] [expr $x + 1] [expr $y + 1] ] ] ==0 } {
#if {([lsearch [$c gettags current] drag] ==-1) && ([lsearch [$c gettags current] enveloppe] ==-1) } 
# 0, CanvasGere passe  1, on dtruit l'enveloppe rouge et on prpare l'enveloppe grise de slection multiple
catch {$c dtag all cible}
catch {$c delete enveloppe}
#mise  jour barre des boutons du bas
catch {destroy .waction}
set CanvasGere 1
#ajout du tag CanvasGroup  l'enveloppe grise
$c create rectangle $x $y $x $y -outline gray50 -width 3 -stipple gray50 -tags "CanvasGroup"
} elseif { (([llength [$c find withtag cible]] ==0) || ([llength [$c find withtag cible]] ==1)) && ([lsearch [$c gettags current] enveloppe] ==-1) } {
#autrement, c'est qu'il y a des objets
# s'il n'y a pas d'objet dj slectionn sous le pointeur (cible==0), ou un objet slectionn (cible==1) sans enveloppe autour (enveloppe==-1)
if {[lsearch -regexp [$c gettags current] uident*] !=-1} {
#On le slectionne, avec une enveloppe rouge et on cre la barre d'outils du bas
catch {$c dtag all cible}
catch {$c delete enveloppe}
$c addtag cible withtag current
set typ [lindex [$c gettags current] [lsearch -regexp [$c gettags current] type*]]

creetool $typ $c
$c focus current


createenveloppe $c current
}
}
}


proc CanvasDrag {c x y} {
global lastX lastY CanvasGere tid
#si on est en train de tracer le rectangle de slection
if {$CanvasGere == 1} {
# pour modifier le rectangle de slection gris
$c coords CanvasGroup $lastX $lastY $x $y
# si on n'est pas en train de tracer un rect de slection et qu'on est pas entrain de redimmensionner l'enveloppe (current enveloppe -1)
} elseif {[lsearch [$c gettags current] enveloppe] ==-1} {
$c focus ""
# on dplace tous les objets concernes (groupe ou seul)
foreach tg [$c find withtag cible] {
if {[lsearch -regexp [$c gettags $tg] uident*] !=-1} {
set typ [lindex [$c gettags $tg] [lsearch -regexp [$c gettags $tg] type*]]
switch $typ {


   typetext {
         textmove $c $tg $x $y $lastX $lastY
         }
   typebouton2 {
	bouton2move $c $tg $x $y $lastX $lastY
   	}
   default {
         $c move $tg [expr $x-$lastX] [expr $y-$lastY]}
         }
   }}
$c move enveloppe [expr $x-$lastX] [expr $y-$lastY]
set lastX $x
set lastY $y
}
}


proc CanvasStopDrag {c x y} {
global lastX lastY CanvasGere tid
if {$CanvasGere == 1} {
	# si on construisait le rectangle de slection gris
	set lcordr [$c coords CanvasGroup]
	#overlapping? or enclosed?
	# on tague tous les objets avec cible
	foreach it [$c find overlapping [lindex $lcordr 0] [lindex $lcordr 1] [lindex $lcordr 2] [lindex $lcordr 3] ] {
		if {[lsearch -regexp [$c gettags $it] uident*] !=-1} {
			$c addtag cible withtag $it
			}
	}
#overlapping?
#on rinitialise la barre d'outils si pas d'objet slectionn (<2-> le canvas seul)
	if {[llength [$c find overlapping [lindex $lcordr 0] [lindex $lcordr 1] [lindex $lcordr 2] [lindex $lcordr 3] ]] < 2} {
		creetool canvas $c
		}
#on efface le rectangle gris et on met une enveloppe rouge si besoin
	$c delete CanvasGroup
	if {[llength [$c find withtag cible]] !=0} {
		createenveloppe $c cible
		}
} else {

# si on n'tait pas en train de tracer le rectangle de slection multiple
#On met le focus sur le texte si le widget en dispose
	set CanvasGere 0
	if {[llength [$c find withtag cible]] ==1} {
		set typ [lindex [$c gettags current] [lsearch -regexp [$c gettags current] type*]]

		if {[testeliendirect [lindex [$c gettags current] [lsearch -regexp [$c gettags current] uident*]] $c $typ] !=0} {return}
		switch $typ {
			typebouton2 {
			$c focus [lindex $tid([lindex [$c gettags current] [lsearch -regexp [$c gettags current] uident*]]) 4]
			focus $c
			}
			typetext {$c focus current}
		}
	}
}

}


proc setcrtl {keysy} {
global crtlflag
if {$keysy == "Control_R" || $keysy == "Control_L"} {
set crtlflag 1
}
}

proc unsetcrtl {} {
global crtlflag
set crtlflag 0
}

proc testeliendirect {uid c typ} {
global crtlflag tabpage indexpage totalpage nompage
	if {$crtlflag == 1} {
		if {$typ == "typebouton2"} {
			if {[llength [array get tabpage $uid]] !=0} {
				if {[expr $tabpage($uid) -1] < $totalpage && [expr $tabpage($uid) -1] >=0} {
				sauvepage $c $indexpage
				set indexpage [expr $tabpage($uid) -1]
				affichenouvellepage $c
				.wcorner.wtool.labelpage configure -text $nompage($indexpage)
				return 1
				} else {
				tk_messageBox -message [mc {Nom de page non valide}] -title "Kidistb"
				return 1
				}
			}
		}
		if {$typ == "typebouton1"} {
		sauvepage $c $indexpage
			if {[lsearch [$c gettags $uid] pagesuiv] != -1} {set indpage [expr $indexpage + 1]}
			if {[lsearch [$c gettags $uid] pageprec] != -1} {set indpage [expr $indexpage - 1]}
			if {[lsearch [$c gettags $uid] sommaire] != -1} {set indpage 0}
			if {$indpage < $totalpage && $indpage >=0} {
			set indexpage $indpage
			affichenouvellepage $c
			} else {
			tk_messageBox -message [mc {La page n'est pas valide}] -title "Kidistb"
			return 1
			}
		.wcorner.wtool.labelpage configure -text $nompage($indexpage)
		}
	}
return 0
}

